static char *cvs_id =" $Id: wv_lib.c,v 1.5 2002/10/21 14:58:43 berar Exp $ ";
/*  wv_lib : image princeton (Winview )  */
/*  jf berar */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
/*-----------------------------------------------------------*/
#include "wv_def.h"
/*-----------------------------------------------------------*/
typedef struct               /* old structure, not used */
{   INT16U  x_det, y_det;
    INT16U  x_dim, y_dim;
    INT16U  exp_hour, exp_min;
    INT16U  d_type;
    INT32   frames;
    INT32   expos_msec;
    float   header_ver;
    float   expos_sec;
    char    exp_date[10];
    char    sw_version[16];
    int     used_frames;
    INFO   info;
    FILE   *file;
    char   *name;
    } WV_HDR;
/*-----------------------------------------------------------*/
#define WV_HDR_LG  4100L
XY_HDR   *wv_gethdr (FILE *f);    
void      wv_hdrfill (FILE *f, XY_HDR *h);    
/*-----------------------------------------------------------*/
/* read winview file header                                  */
/*-----------------------------------------------------------*/
XY_HDR *wv_gethdr( FILE *f)   /* quick open, just get image size */
{   INT16U  val;
    XY_HDR  *h;

    /* we use x_det or x_size to recognize the swapping */
    fseek( f, 6L, 0);
    fread( &val, sizeof(INT16U), 1, f);
    if (val == 0)    /* occurs in rewriten file by wv */
    {  fseek( f, 42L, 0);
       fread( &val, sizeof(INT16U), 1, f);
       if (val == 0)     /* last hope in zero */
       {  fseek( f, 0, 0);
          fread( &val, sizeof(INT16U), 1, f);
       }  }
    if ( (val & 0xF000) != 0  )  xy_setswapon();
             else xy_setswapoff();

    h = (XY_HDR *) malloc(sizeof(XY_HDR));
    memset(h, 0, sizeof(XY_HDR));
    xy_fread16( &h->x_dim,    42L, f);
    xy_fread16( &val,  108L, f);
    switch (val)
    {  case 0 : h->t_data = T_FLOAT; break;
       case 1 : h->t_data = T_INT32; break;
       case 2 : h->t_data = T_INT16; break;
       case 3 : h->t_data = T_INT16U; break;
       default :h->t_data = INVALID_DATA;
       }
    xy_fread16( &h->y_dim,   656L, f); 
    xy_fread32( &h->frames, 1446L, f); 
    h->header_end = WV_HDR_LG;
    return h;    
    }
/*-----------------------------------------------------------*/
#define BUF_LG 127
void wv_hdrfill( FILE *f, XY_HDR *h)
{   INT16U  val, valt, valh, valm;
    INT32   val32;
    float   valf;
    char *c, t[12], buffer[BUF_LG+1];
    int roi;
    INT16U sx,sy,ex,ey,gx,gy;

    h->edf_disp = h->edf_used = 0;
    xy_edfstr( h, "HeaderID", "EH:000001:000000:000000");
    xy_edfstr( h, "ByteOrder", "LowByteFirst");
    switch (h->t_data)
    {   case T_INT16U : c = "UnsignedShort"; break;
        case T_INT32 : c = "SignedInt"; break;
        case T_FLOAT : c = "FloatValue"; break;
        default : c = "Unknown";
        }
    xy_edfstr( h, "DataType", c);
    sprintf(buffer,"%hd", h->x_dim);
    xy_edfstr(h, "Dim_1", buffer);
    sprintf(buffer,"%hd", h->y_dim);
    xy_edfstr(h, "Dim_2", buffer);
    sprintf(buffer,"%d", h->frames);
    xy_edfstr(h, "Image", buffer);
   
    xy_fread16( &valt,  4L, f);    /* exposure ms */
    xy_fread16( &val,  6L, f);
    sprintf(buffer,"%hd", val);
    xy_edfstr(h, "Detector_Xsize", buffer);
    xy_fread32( (INT32*) &valf, 10L, f);
    h->expos_sec = valf;
    if (valf != 0 )
    {  sprintf(buffer,"%f", valf);
       xy_edfstr(h, "Exposure_sec", buffer);
       }
    xy_fread16( &val, 18L, f);
    sprintf(buffer,"%hd", val);
    xy_edfstr(h, "Detector_Ysize", buffer);
    fseek( f, 20L, 0);
    fread( t, 10 , 1, f);
    xy_edfstr(h, "Experiment_date", t);
    xy_fread16( &valh, 30L, f); 
    xy_fread16( &valm,  32L, f); 
    sprintf(buffer,"%02hd:%02hd", valh, valm);
    xy_edfstr(h, "Experiment_time", buffer);

    if (valt == 0xffff ) 
    {   xy_fread32( &val32, 660L, f);
        if (val32 != 0xffffffff )
        {  sprintf(buffer,"%d", val32);
           xy_edfstr(h, "Exposure_msec", buffer);
        }  }
    else  
    {   sprintf(buffer,"%hd", valt);
        xy_edfstr(h, "Exposure_msec", buffer);
        }
/*    fseek( f, 688L, 0);
    fread( h->sw_version, 16 , 1, f);
*/    
    for (roi=0;roi<10;roi++)
    {  fseek( f, roi*12+1512L, 0);
       xy_fread16( &sx, roi*12+1512L, f); 
       xy_fread16( &ex, roi*12+1514L, f); 
       xy_fread16( &gx, roi*12+1516L, f); 
       xy_fread16( &sy, roi*12+1518L, f); 
       xy_fread16( &ey, roi*12+1520L, f); 
       xy_fread16( &gy, roi*12+1522L, f); 
       if ( gx && gy )
       {  sprintf(buffer,"%d X=(%hd-%hd)/%hd Y=(%hd-%hd)/%hd", roi+1, sx,ex,gx,sy,ey,gy);
          xy_edfstr(h, "ROI_info", buffer);
       }  }      
    sprintf(buffer, "%s (%s) based on Winhead.txt (1.6)\n", __FILE__, __DATE__);
    c = strrchr( buffer, '\n');
    if ( c ) *c=0;
    c = strrchr( buffer, '\r');
    if ( c ) *c=0;
    xy_edfstr(h, "Software", buffer);
    if (h->t_data == INVALID_DATA)
    {    xy_fputhdr(stderr, h, 1);
         V_ERROR(" not supported data type!\n");
         }
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
XY_HDR  *wv_open (char * name, char *msg, int quick)
{   FILE   *f;
    XY_HDR *h;
    char   *n, buffer[200];
    strcpy (buffer, name);
    if (strstr(buffer, ".spe") == NULL && strstr(buffer, ".SPE") == NULL) strcat(buffer, ".spe");
    f = fopen( buffer, "rb");
    if ( f == NULL ) 
    {  strcpy (buffer, name);
       if (strstr(buffer, ".spe") == NULL && strstr(buffer, ".SPE") == NULL) strcat(buffer, ".SPE");
       f = fopen( buffer, "rb");
       }
    if ( f == NULL ) v_error( __FILE__, "wv_open : unable to open %s file '%s(.spe|.SPE)'\n", msg, name);
    h = wv_gethdr( f ); 
    if (h->t_data == INVALID_DATA || quick == 0 )
    {    wv_hdrfill(f , h);
         }
    else h = wv_gethdr( f );
    n = (char * ) malloc( 1+strlen(buffer));
    strcpy (n, buffer);
    h->name = n;
	 h->xy_mode = WV_XYMODE;
    h->file = f;
    return h;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* recupere une image depuis la position courante du fichier */
int wv_getraw(XY_HDR *h, IMAGE *img, void *val, int pos)
{   int  i, j, k, xread, xseek, xfor, yfor, size;
    long   p;
    INT32    *vl;
    INT16U   *vu;
    float    *vf;
    char     *v;
   switch  (h->t_data)
   {  case T_INT16U : size = sizeof(INT16U);  break;
      case T_INT32  : size = sizeof(INT32);  break;
      case T_FLOAT  : size = sizeof(float);  break;
      }
   p = WV_HDR_LG + size * ( (pos-1) * img->osize
           + img->y_omin * img->x_osize + img->x_omin );
   xread=size*img->x_tsize;
   xseek=size*img->x_osize;
   xfor=img->x_tsize;
   yfor=img->y_tsize;
   for ( k=0, vu=val, vf=val; k<yfor; k++, vu+=xfor, vf+=xfor, p+=xseek )
   {   fseek( h->file, p, 0);
       switch  (h->t_data)
       {  case T_INT16U : vu = (INT16U *) val + k * xfor;  
                          v = (char *) vu;  break;
          case T_INT32  : vl = (INT32 *) val + k * xfor;  
                          v = (char *) vl;  break;
          case T_FLOAT  : vf = (float *) val + k * xfor;  
                          v = (char *) vf;  break;
          }
       if ( (j=fread( v, xread, 1, h->file)) != 1 )
       if ( k == 0 )  return 0;
       else
       {   fprintf(stderr, "wv_getraw error %d reading %d image at y = %d, y_min %d, pos %d\n",
                  errno, j, k+img->y_omin, img->y_omin, pos);
           return -1;
           }
       if (xy_doswap)  switch  (h->t_data)
       {  case T_INT16U : for (i=0; i < xfor; i++) xy_eswap16 (vu+i);
                          break;
          case T_INT32  : for (i=0; i < xfor; i++) xy_eswap32 (vl+i);
                          break;
          case T_FLOAT  : for (i=0; i < xfor; i++) xy_eswap32 ((INT32 *) (vf+i));
                          break;
          }
       }   
   return img->y_tsize;    
   }
/*-----------------------------------------------------------*/
int wv_getimg(XY_HDR *h, IMAGE *img, int pos)
{   INT16U *raw;
    float *rawf;
    int i;
   switch  (h->t_data)
   {  case T_INT16U :     
         raw = (INT16U *) malloc(img->osize * sizeof(INT16U));
         i = wv_getraw(h, img, raw, pos);
         xy16u_bind( img, raw);
         free(raw);
	 break;
      case T_FLOAT  : 
         rawf = (float *) malloc(img->osize * sizeof(float));
         i = wv_getraw(h, img, rawf, pos);
         xy32f_bind( img, rawf);
         free(rawf);
	 break;
      }
    img->name = h->name;
    return i;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/

